Subject: bug#74606: 31.0.50; Another rsvg API change

From: Manuel Giraud <[email-masked]>
Date: Mon, 02 Dec 2024 15:14:54 +0100

Manuel Giraud <[email-masked]> writes:

> Manuel Giraud <[email-masked]> writes:
>
>> Osama Rebach <[email-masked]> writes:
>>
>>> rsvg_handle_get_pixbuf_and_error is defined in librsvg 2.59, so the patch
>>> should guard against 2.59 instead of 2.58
>>
>> Thanks.  I have based my patch on this comment:
>> https://gitlab.gnome.org/GNOME/librsvg/-/blob/main/include/librsvg/rsvg-pixbuf.h?ref_type=heads#L52
>>
>> Now, I'm looking on the librsvg repo for a more valid source of
>> information.
>
> Ok, so if I'm not mistaken the patch that introduces the
> rsvg_handle_get_pixbuf_and_error API (and deprecated the other) is this
> one:
> https://gitlab.gnome.org/GNOME/librsvg/-/commit/85cdba02a3e126c1099a62b3d6421ac0cb2d790b
>
> On this page, when you unfold the link "Tags containing commit", you can
> see that 2.58.90 is the first one.  So maybe, I should use this version
> instead.  WDYT?
>
> The "Deprecated: 2.58" from the header looks like a copy/paste
> mistake.

Here is a patch to be applied on emacs-30.
>From 5ffc64b52427309a9e171d54520ecab2e408d62e Mon Sep 17 00:00:00 2001
From: Manuel Giraud <[email-masked]>
Date: Mon, 2 Dec 2024 15:11:52 +0100
Subject: [PATCH] Fix the version of librsvg API change

* src/image.c (init_svg_functions, svg_load_image): The version
introducing 'rsvg_handle_get_pixbuf_and_error' is 2.58.90 not
2.58.0.
---
 src/image.c | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

diff --git a/src/image.c b/src/image.c
index 43220758324..46e8b48aced 100644
--- a/src/image.c
+++ b/src/image.c
@@ -11688,7 +11688,7 @@ DEF_DLL_FN (void, rsvg_handle_get_dimensions,
 DEF_DLL_FN (gboolean, rsvg_handle_set_stylesheet,
 	    (RsvgHandle *, const guint8 *, gsize, GError **));
 #  endif
-#  if LIBRSVG_CHECK_VERSION (2, 58, 0)
+#  if LIBRSVG_CHECK_VERSION (2, 58, 90)
 DEF_DLL_FN (GdkPixbuf *, rsvg_handle_get_pixbuf_and_error, (RsvgHandle *, GError **));
 #  else
 DEF_DLL_FN (GdkPixbuf *, rsvg_handle_get_pixbuf, (RsvgHandle *));
@@ -11751,7 +11751,7 @@ init_svg_functions (void)
 #if LIBRSVG_CHECK_VERSION (2, 48, 0)
   LOAD_DLL_FN (library, rsvg_handle_set_stylesheet);
 #endif
-#if LIBRSVG_CHECK_VERSION (2, 58, 0)
+#if LIBRSVG_CHECK_VERSION (2, 58, 90)
   LOAD_DLL_FN (library, rsvg_handle_get_pixbuf_and_error);
 #else
   LOAD_DLL_FN (library, rsvg_handle_get_pixbuf);
@@ -11800,7 +11800,7 @@ init_svg_functions (void)
 #  if LIBRSVG_CHECK_VERSION (2, 48, 0)
 #   undef rsvg_handle_set_stylesheet
 #  endif
-#  if LIBRSVG_CHECK_VERSION (2, 58, 0)
+#  if LIBRSVG_CHECK_VERSION (2, 58, 90)
 #   undef rsvg_handle_get_pixbuf_and_error
 #  else
 #   undef rsvg_handle_get_pixbuf
@@ -11845,7 +11845,7 @@ init_svg_functions (void)
 #  if LIBRSVG_CHECK_VERSION (2, 48, 0)
 #   define rsvg_handle_set_stylesheet fn_rsvg_handle_set_stylesheet
 #  endif
-#  if LIBRSVG_CHECK_VERSION (2, 58, 0)
+#  if LIBRSVG_CHECK_VERSION (2, 58, 90)
 #   define rsvg_handle_get_pixbuf_and_error fn_rsvg_handle_get_pixbuf_and_error
 #  else
 #   define rsvg_handle_get_pixbuf fn_rsvg_handle_get_pixbuf
@@ -12354,7 +12354,7 @@ svg_load_image (struct frame *f, struct image *img, char *contents,
 
   /* We can now get a valid pixel buffer from the svg file, if all
      went ok.  */
-#if LIBRSVG_CHECK_VERSION (2, 58, 0)
+#if LIBRSVG_CHECK_VERSION (2, 58, 90)
   pixbuf = rsvg_handle_get_pixbuf_and_error (rsvg_handle, &err);
   if (err) goto rsvg_error;
 #else
-- 
2.47.0

-- 
Manuel Giraud